<!--  -->
<template>
  <div class="feedback_list_box" :style="'height:' + fullHeight + 'px'">
    <!-- 页头 -->
    <div class="feedback_list_headr">
      <el-page-header title @back="goBack" content="意见反馈"></el-page-header>
    </div>

    <!-- 主内容 -->
    <mescroll-vue ref="mescroll" :down="mescrollDown" :up="mescrollUp" @init="mescrollInit">
      <div class="feedback_list_box_main">
        <ul class="feedback_list_box_main_ul" v-if="isShow">
          <li class="feedback_list_box_main_li" v-for="(item, index) in this.redata" :key="index">
            <div class="feedback_list_box_main_li_box">
              <!-- 头像 -->
              <div class="main_li_portrait">
                <img src="../../assets/imageOne/750.png" alt class="main_li_portrait_img" />
              </div>

              <!-- 用户昵称和时间 -->
              <div class="main_li_box">
                <div class="main_li_name">{{ item.name }}</div>
                <div class="main_li_time">{{ item.time }}</div>
              </div>

              <!-- 右箭头 -->
              <div class="main_li_right">
                <img src="../../assets/imageOne/15.png" alt class="main_li_right_img" />
              </div>
            </div>
          </li>
        </ul>

        <!-- 暂无数据 -->
        <div class="content-block" v-else>
          <img src="../../assets/imageOne/423.png" alt class="content-block-img" />
          <div class="content-block-text">暂无数据</div>
        </div>
        <!-- 暂无数据 -->
      </div>
    </mescroll-vue>
  </div>
</template>

<script>
// 引入mescroll的vue组件
import MescrollVue from "mescroll.js/mescroll.vue";
export default {
  //import引入的组件需要注入到对象中才能使用
  components: {
    MescrollVue // 注册mescroll组件
  },
  data() {
    //这里存放数据
    return {
      fullHeight: document.documentElement.clientHeight,
      redata: [], //后端数据
      isShow: false, //判断是否有数据
      FenShow: true,
      //测试
      mescroll: null, // mescroll实例对象
      mescrollDown: {}, //下拉刷新的配置. (如果下拉刷新和上拉加载处理的逻辑是一样的,则mescrollDown可不用写了)
      mescrollUp: {
        // 上拉加载的配置.
        callback: this.upCallback, // 上拉回调,此处简写; 相当于 callback: function(page, mescroll) { }
        //以下是一些常用的配置,当然不写也可以的.
        page: {
          num: 0, //当前页 默认0,回调之前会加1; 即callback(page)会从1开始
          size: 7 //每页数据条数,默认10
        },
        isBounce: true, //根据记录的滚动条高度回弹
        htmlNodata: '<p class="upwarp-nodata">-- 已经到底了! --</p>',
        noMoreSize: 7, //如果列表已无数据,可设置列表的总数量要大于5才显示无更多数据;
        // 避免列表数据过少(比如只有一条数据),显示无更多数据会不好看
        // 这就是为什么无更多数据有时候不显示的原因
        toTop: {
          //回到顶部按钮
          // src: "../../../static/gotop.png", //图片路径,默认null,支持网络图
          src:
            "http://pic.51yuansu.com/pic3/cover/00/65/23/5896fa4bc81fc_610.jpg", //图片路径,默认null,支持网络图
          offset: 800 //列表滚动1000px才显示回到顶部按钮
        },
        empty: {
          //列表第一页无任何数据时,显示的空提示布局; 需配置warpId才显示
          warpId: "xxid", //父布局的id (1.3.5版本支持传入dom元素)
          icon: "./static/mescroll/mescroll-empty.png", //图标,默认null,支持网络图
          tip: "暂无相关数据~" //提示
        },
        onScroll: function(mescroll, y, isUp) {
          //监听滚动条
          // console.log(y);
        },
        lazyLoad: {
          use: true // 是否开启懒加载,默认false
        }
      },
      aggregate: "" //后端传来数据的总条数
    };
  },
  beforeRouteEnter(to, from, next) {
    // 如果没有配置顶部按钮或isBounce,则beforeRouteEnter不用写
    next(vm => {
      // 滚动到原来的列表位置,恢复顶部按钮和isBounce的配置
      vm.$refs.mescroll && vm.$refs.mescroll.beforeRouteEnter();
    });
  },
  beforeRouteLeave(to, from, next) {
    // 如果没有配置顶部按钮或isBounce,则beforeRouteLeave不用写
    // 记录列表滚动的位置,隐藏顶部按钮和isBounce的配置
    this.$refs.mescroll && this.$refs.mescroll.beforeRouteLeave();
    next();
  },

  //监听属性 类似于data概念
  computed: {},
  //监控data中的数据变化
  watch: {
    fullHeight(val) {
      //监控浏览器高度变化
      if (!this.timer) {
        this.fullHeight = val;
        this.timer = true;
        let that = this;
        setTimeout(function() {
          //防止过度调用监测事件，导致卡顿
          that.timer = false;
        }, 400);
      }
    }
  },
  //方法集合
  methods: {
    mescrollInit(mescroll) {
      this.mescroll = mescroll; // 如果this.mescroll对象没有使用到,则mescrollInit可以不用配置
    },

    // 上拉回调 page = {num:1, size:10}; num:当前页 ,默认从1开始; size:每页数据条数,默认10
    upCallback(page, mescroll) {
      let _this = this;
      this.$axios({
        method: "get",
        url: "bigservers/check_leaving",
        params: {
          page: this.mescrollUp.page.num
        }
      })
        .then(res => {
          //判断data中的变量是否为空 ，为空的话存后端发来的总条数
          if (this.aggregate === "") {
            //存变量
            this.aggregate = res.data.num;
            var b = "7";
            this.aggregate = this.aggregate / b;
            this.aggregate = Math.ceil(this.aggregate); //将小数点转换为整数
          }

          //删除了默认的每页条数后判断数是否大于页码
          if (this.mescrollUp.page.num <= this.aggregate) {
            this.$axios({
              method: "get",
              url: "bigservers/check_leaving",
              params: {
                page: this.mescrollUp.page.num
              }
            })
              .then(res => {
                let arr = res.data.dat;
                // 如果是第一页需手动置空列表
                if (page.num === 1) this.redata = [];
                // 把请求到的数据添加到列表
                this.redata = this.redata.concat(arr);
                // 数据渲染成功后,隐藏下拉刷新的状态
                this.$nextTick(() => {
                  mescroll.endSuccess(arr.length);
                });
                if (res.data.num === 0) {
                  _this.FenShow = false;
                  _this.isShow = false
                } else if (res.data.num !== 0) {
                  _this.axiosShow = true;
                  _this.FenShow = true;
                  _this.isShow = true
                }
              })
              .catch(error => {
                mescroll.endErr();
              });
          } else if (this.mescrollUp.page.num > this.aggregate) {
            // 数据渲染成功后,隐藏下拉刷新的状态
            this.$nextTick(() => {
              mescroll.endSuccess(this.aggregate);
            });
          }

          if (this.aggregate === 0) {
            this.axiosShow = false;
            this.FenShow = false;
          }
        })
        .catch(err => {
          mescroll.endErr();
          console.log(err);
        });
    },

    //动态获取浏览器高度
    get_boderHeight() {
      const that = this;
      window.onresize = () => {
        return (() => {
          window.fullHeight = document.documentElement.clientHeight;
          that.fullHeight = window.fullHeight;
        })();
      };
    },

    //点击返回系统设置
    goBack() {
      let _this = this;
      // _this.$router.push("/system");
      _this.$router.replace("/system");
    }
  },
  //生命周期 - 创建完成（可以访问当前this实例）
  created() {},
  //生命周期 - 挂载完成（可以访问DOM元素）
  mounted() {
    let _this = this;
    this.get_boderHeight();
  }
};
</script>
<style lang='scss'>
@import "../../assets/style/bus.scss";
@import "../../assets/style/scss/feedback_list.scss";
</style>